// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/lfsr_apb_wrapper.hpp"



lfsr_apb_wrapper::lfsr_apb_wrapper( sc_core::sc_module_name name_ ) :
    sc_core::sc_module( name_ ),
    pclk("pclk"),
    presetn("presetn"),
    paddr("paddr"),
    psel("psel"),
    penable("penable"),
    pwrite("pwrite"),
    pwdata("pwdata"),
    pready("pready"),
    prdata("prdata"),
    prdata_var_0(0UL),
    prdata_partial0(uint8_t(0U)),
    out_partial_sig("out_partial_sig"),
    old_out_partial_sig(uint8_t(0U)),
    out_partial_sig_sig_var(uint8_t(0U)),
    lfsr_0_linear_feedback(false)
{
    pready.initialize( false );
    prdata.initialize( 0UL );
    out_partial_sig = uint8_t(0U);

    SC_METHOD( lfsr_0_process );
    sensitive << pclk.pos();

    SC_METHOD( globact_process );
    sensitive << out_partial_sig;
}

lfsr_apb_wrapper::~lfsr_apb_wrapper()
{}

void lfsr_apb_wrapper::hif_cone_lfsr_0_linear_feedback()
{
    hif_cone_out_partial_sig();
    lfsr_0_linear_feedback = !static_cast< bool >( static_cast< bool >( static_cast<
         uint8_t >( out_partial_sig_sig_var >> uint8_t(3U) ) & uint8_t(1U) ) ^ static_cast<
         bool >( static_cast< uint8_t >( out_partial_sig_sig_var >> uint8_t(7U)
         ) & uint8_t(1U) ) );
}


void lfsr_apb_wrapper::hif_cone_prdata_partial0()
{
    hif_cone_out_partial_sig();
    prdata_partial0 = out_partial_sig_sig_var;
}


void lfsr_apb_wrapper::hif_cone_out_partial_sig()
{
    if (out_partial_sig.read() != old_out_partial_sig)
    {
        old_out_partial_sig = out_partial_sig.read();
        out_partial_sig_sig_var = old_out_partial_sig;
    }
}


void lfsr_apb_wrapper::lfsr_0_process()
{
    if (presetn.read())
    {
        hif_cone_out_partial_sig();
        out_partial_sig_sig_var = uint8_t(0U);
        out_partial_sig = out_partial_sig_sig_var;
        pready = false;
    }
    else
    {
        hif_cone_lfsr_0_linear_feedback();
        hif_cone_out_partial_sig();
        out_partial_sig = static_cast< uint8_t >( static_cast< uint8_t >( static_cast<
             uint8_t >( static_cast< uint8_t >( static_cast< uint8_t >( static_cast<
             uint8_t >( static_cast< uint8_t >( static_cast< uint8_t >( static_cast<
             uint8_t >( static_cast< uint8_t >( static_cast< uint8_t >( static_cast<
             uint8_t >( static_cast< uint8_t >( static_cast< bool >( static_cast<
             uint8_t >( out_partial_sig_sig_var >> uint8_t(6U) ) & uint8_t(1U) 
            ) << uint8_t(1U) ) | static_cast< uint8_t >( static_cast< bool >( static_cast<
             uint8_t >( out_partial_sig_sig_var >> uint8_t(5U) ) & uint8_t(1U) 
            ) ) ) << uint8_t(1U) ) | static_cast< uint8_t >( static_cast< bool >
            ( static_cast< uint8_t >( out_partial_sig_sig_var >> uint8_t(4U) ) &
             uint8_t(1U) ) ) ) << uint8_t(1U) ) | static_cast< uint8_t >( static_cast<
             bool >( static_cast< uint8_t >( out_partial_sig_sig_var >> uint8_t
            (3U) ) & uint8_t(1U) ) ) ) << uint8_t(1U) ) | static_cast< uint8_t >
            ( static_cast< bool >( static_cast< uint8_t >( out_partial_sig_sig_var
             >> uint8_t(2U) ) & uint8_t(1U) ) ) ) << uint8_t(1U) ) | static_cast<
             uint8_t >( static_cast< bool >( static_cast< uint8_t >( out_partial_sig_sig_var
             >> uint8_t(1U) ) & uint8_t(1U) ) ) ) << uint8_t(1U) ) | static_cast<
             uint8_t >( static_cast< bool >( out_partial_sig_sig_var & uint8_t(1U
            ) ) ) ) << uint8_t(1U) ) | static_cast< uint8_t >( lfsr_0_linear_feedback
             );
        pready = true;
    }
}

void lfsr_apb_wrapper::globact_process()
{
    prdata_var_0 = prdata.read();
    hif_cone_prdata_partial0();
    prdata_var_0 = prdata_var_0 & 4294967040UL | prdata_partial0;
    prdata = prdata_var_0;
}



